Subject: Re: [RFC, VLAN]: Propagate selected feature bits to VLAN devices

From: Patrick McHardy <[email-masked]>
Date: Thu, 22 May 2008 20:25:10 +0200

Waskiewicz Jr, Peter P wrote:
>> Waskiewicz Jr, Peter P wrote:
>>     
>>> The issue is how does the driver know how to pull those 
>>>       
>> flags off the 
>>     
>>> VLAN device when the parent has TSO or CSUM offload disabled?  The 
>>> only way I could come up with it was in my original patch in the 
>>> drivers to loop through the entire VLAN group array, and clear the 
>>> flag on existing devices.
>>>   
>>>       
>> Yes, thats also what my patch is doing. Not a big deal I 
>> guess, we're doing that for all kinds of notifications 
>> already and nobody ever complained.
>>     
>
> I guess I misunderstood what you were suggesting to re-implement with
> Herbert.  I like your current patch as-is, but if something different is
> coming, I'll just sit tight for it.  I already spun the ixgbe, igb, and
> e1000e patches to use the new interface, and they should be coming out
> shortly.  But if we need to update them later, that's cool.

The idea is simply to replace the NETIF_F_VLAN_TSO and checksumming
flag by a flag mask that specifies the features that may be propagated
to the VLAN devices.

The change to your driver will most likely be something like:

- dev->features |= NETIF_F_VLAN_TSO | ...
+ dev->vlan_features |= NETIF_F_TSO | NETIF_F_TSO6 | NETIF_F_CSUM_ALL | ...

I'll send the patch tommorrow, I'm currently busy with other things.